defmodule Nulla.Utils do
  alias Finch

  def fetch_remote_actor(uri) do
    headers = [
      {"Accept", "application/activity+json"},
      {"User-Agent", "Nulla/1.0"},
      {"Host", URI.parse(uri).host}
    ]

    request = Finch.build(:get, uri, headers)

    case Finch.request(request, Nulla.Finch) do
      {:ok, %Finch.Response{status: 200, body: body}} ->
        case Jason.decode(body) do
          {:ok, data} -> {:ok, data}
          _ -> {:error, :invalid_json}
        end

      {:ok, %Finch.Response{status: code}} when code in 300..399 ->
        {:error, :redirect_not_followed}

      _ ->
        {:error, :actor_fetch_failed}
    end
  end
end
