defmodule Nulla.KeyGen do
  def gen do
    key = :public_key.generate_key({:rsa, 2048, 65_537})
    entry = :public_key.pem_entry_encode(:RSAPrivateKey, key)

    private_pem =
      :public_key.pem_encode([entry])
      |> String.trim_trailing()
      |> Kernel.<>("\n")

    [private_key_code] = :public_key.pem_decode(private_pem)
    private_key = :public_key.pem_entry_decode(private_key_code)
    {:RSAPrivateKey, _, modulus, exponent, _, _, _, _, _, _, _} = private_key
    public_key = {:RSAPublicKey, modulus, exponent}
    public_key = :public_key.pem_entry_encode(:SubjectPublicKeyInfo, public_key)

    public_pem =
      :public_key.pem_encode([public_key])
      |> String.trim_trailing()
      |> Kernel.<>("\n")

    {public_pem, private_pem}
  end
end
